Bug 25974 - Make GRUB2 bootable on GPT
: Make GRUB2 bootable on GPT
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/alterator-vm)
: unstable
: all Linux
: P3 normal
Assigned To:
:
:
:
:
: 23155
  Show dependency tree
 
Reported: 2011-08-02 15:13 by
Modified: 2014-02-16 15:57 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2011-08-02 15:13:53
Для того, чтобы GRUB2 установился на GPT (и загрузился после этого) требуются
дополнительные действия:

Create a 1 MiB (minimum size) partition using gdisk or GNU Parted with no
filesystem. The location of the partition in the partition table does not
matter but it should be within the first 2 TiB region of the GPT disk. It is
advisable to put it somewhere in the beginning of the disk before the /boot
partition. Set the partition type to "EF02" in GPT fdisk or set "bios_grub"
flag on in GNU Parted or GParted.

Предлагается в случае создания таблицы разделов GPT (>2Tb) добавлять автоматом
такой спецраздел.
------- Comment #1 From 2011-08-17 10:36:37 -------
*** Bug 26100 has been marked as a duplicate of this bug. ***
------- Comment #2 From 2011-08-17 14:46:46 -------
GPT устанавливается автоматически для всех разделов более двух терабайт. От
перемены слов результат не меняется.
------- Comment #3 From 2011-08-17 14:51:06 -------
(В ответ на комментарий №2)
> GPT устанавливается автоматически для всех разделов более двух терабайт. От
> перемены слов результат не меняется.

Вопрос не в этом, а в том, кому чинить. Вы уж там определитесь полюбовно. У
vitty@ есть конкретное предложение. Бага нехорошая, действительно блокер.
------- Comment #4 From 2011-08-17 14:53:38 -------
тут всё сложнее. Например, как быть, если устанавливается не grub а lilo ?

Впрочем, сделать мегабайтный раздельчик никто не запрещает. Но вот как это
сделать автоматом ?
------- Comment #5 From 2011-08-17 15:04:29 -------
(В ответ на комментарий №4)
> тут всё сложнее. Например, как быть, если устанавливается не grub а lilo ?
> 

Тогда ручками. Мы не должны делать автомат на все варианты, никто так не
делает. Нм нужен один простой автоматический способ, который не заставляет
вызывать сторонние программы при установке. Желающие иного сделают все сами.
------- Comment #6 From 2011-08-17 15:19:42 -------
понимаешь ли в чём проблема. GPT включается автоматически для всех дисков более
двух терабайт и объяснять пользователю, что ему нужно сделать какой-то левый
раздел, для того, что бы поставился загрузчик - непонятно как.

А что по этому поводу думает апстрим ? Ходили туда ?
------- Comment #7 From 2011-08-18 03:24:41 -------
(В ответ на комментарий №6)
> понимаешь ли в чём проблема. GPT включается автоматически для всех дисков более
> двух терабайт и объяснять пользователю, что ему нужно сделать какой-то левый
> раздел, для того, что бы поставился загрузчик - непонятно как.
> 

"Ручками" было про желающих поставить lilo. Конечно же, этот раздел надо
создавать автоматически.

> А что по этому поводу думает апстрим ? Ходили туда ?

Апстрим не использует evms. То, что vitty@ предложил, -- workaround. Да, нужно
думать, как его реализовать. Это к спецам по evms. :-)
------- Comment #8 From 2011-08-18 08:08:52 -------
(В ответ на комментарий №7)
> (В ответ на комментарий №6)

> > А что по этому поводу думает апстрим ? Ходили туда ?
> 
> Апстрим не использует evms. То, что vitty@ предложил, -- workaround. Да, нужно
> думать, как его реализовать. Это к спецам по evms. :-)

Алексей, это не смешно. Потребность grub'а в специальном разделе никак не
зависит от наличия или отсуствия evms. Каким инструментом будет сделан этот
специальный раздел - не имеет никакой разницы. Основная проблема - в
необходимости его создавать специально для grub. Именно с этим вопросом и стоит
сходить в upstream grub'а.

Как выкручиваются другие дистрибутивы ? Все при установке создают раздел ? А
если первые два терабайта заняты, то что делают ?
------- Comment #9 From 2011-08-18 08:23:43 -------
https://help.ubuntu.com/community/UEFIBooting
------- Comment #10 From 2011-08-18 08:42:52 -------
EFI - это немного другая тема. в KVM нет EFI, а проблема с GPT присутствует.
------- Comment #11 From 2011-08-18 10:45:47 -------
(В ответ на комментарий №10)
> EFI - это немного другая тема. в KVM нет EFI, а проблема с GPT присутствует.

https://wiki.archlinux.org/index.php/GUID_Partition_Table#GPT_support_in_Kernel

"To enable GRUB2 to embed core.img file in GPT disks for BIOS based systems, a
BIOS Boot Partition of size of about 1 MB (no filesystem) is required. See
below on how to create it. "
------- Comment #12 From 2011-08-18 10:56:18 -------
В любом случае, видимо, это
http://rodsbooks.com/gdisk/
надо собрать  и включить в rescue.
------- Comment #13 From 2011-08-18 11:02:44 -------
у меня gdisk уже давно входит в состав server-light и rescue + устанавливается
по умолчанию.
------- Comment #14 From 2011-08-18 11:22:55 -------
Нужный раздел прекрасно создаётся parted-ом. Проблема в том, что инсталлятор:
а) Не создаёт его при автоматическом разбиении
б) Не позволяет создать руками
Это и приводит к невозможности загрузки.
------- Comment #15 From 2011-08-18 12:07:21 -------
Достаточно оставить 1Mb свободного места в начале диска и нет необходимости
создавать какие-то специальные разделы.

Тимур проверил, это работает.

Соответственно мы сейчас внесём необходимые изменения в alterator-vm, которые
потом нужно будет как следует проверить.
------- Comment #16 From 2011-08-18 12:26:40 -------
(In reply to comment #15)
> Достаточно оставить 1Mb свободного места в начале диска и нет необходимости
> создавать какие-то специальные разделы.

Ну, это одно и то же. Раздел лучше тем, что его никто не запортит (в отличие от
просто места).
------- Comment #17 From 2011-08-18 12:31:03 -------
раздел с нашей точки зрения хуже тем, что его надо будет делать.

На первом этапе ограничимся свободным местом и сообщением о необходимости
оного.
------- Comment #18 From 2011-09-07 15:22:11 -------
Должно быть fixed в alterator-vm-0.4.1-alt17
------- Comment #19 From 2011-09-09 13:04:52 -------
(В ответ на комментарий №18)
> Должно быть fixed в alterator-vm-0.4.1-alt17

Подтверждаю для GPT без efi.
------- Comment #20 From 2012-11-16 22:35:55 -------
(In reply to comment #15)
> Достаточно оставить 1Mb свободного места в начале диска и нет необходимости
> создавать какие-то специальные разделы. Тимур проверил, это работает.
(выбираясь из криокамеры) Да, судя по прочтённой документации GRUB 2 и
http://www.rodsbooks.com/efi-bootloaders/grub2.html -- так и должно быть.  Мало
того, при GPT-разбивке выравнивание первого раздела на границу 1--2 Мб является
нормой, хотя, как и отмечал vitty@, выделенный bios boot partition считается
наиболее безопасным вариантом.

Впрочем, другие дистрибутивы не особо замечены в волнениях по поводу того, что
будет с загрузчиком, если снесут линуксовый корень, где лежат его модули.

> Соответственно мы сейчас внесём необходимые изменения в alterator-vm,
> которые потом нужно будет как следует проверить.
В моих тестах на дисках < 2 Тб с GPT-разбивкой никаких проблем с
установкой/работой grub-pc-2.00 не наблюдается.  Закрываем bug #27133?
------- Comment #21 From 2012-11-16 23:18:41 -------
В EVMS была добавлена возможность создавать GPT разделы типа bios boot
partition (EF02). При автоматической разбивке, если в системе присутствуют
только диски с GPT таблицей (!), создаётся такой раздел с минимальным размером